# Comandos utiles:
#
#   Chequear puertos abiertos: netstat -an | grep <PUERTO>
#   Conectar a un puerto TCP: telnet <HOSTNAME> <PUERTO>
#

import socket as skt

PORT=3490
MYIP="127.0.0.1"
MAXQUEUE=10
MAXMSGSIZE=1024

# El segundo parametro indica el tipo de socket (TCP, UDP, UNIX, etc)
server_socket = skt.socket(skt.AF_INET, skt.SOCK_STREAM)
server_socket.bind((MYIP, PORT))
server_socket.listen(MAXQUEUE)
while True:
    # address es una tupla (<HOST>, <PUERTO>)
    #  en donde <HOST> puede ser la direccion IP (string) o un hostname
    client_socket, address = server_socket.accept()
    data = client_socket.recv(MAXMSGSIZE)
    print('Recibido del cliente ({} bytes): {}'.format(len(data), data))
    # Puede que no envie todos los bytes en el buffer de salida,
    # en ese caso retorna la cantidad de bytes enviados
    sent = client_socket.send(data)
    print('Enviado al cliente ({} bytes): {}'.format(sent, data[0:sent]))
    client_socket.close()
